
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 98
#define YY_END_OF_BUFFER 99
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[457] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   99,   97,   96,   96,   97,   97,
       97,   42,   69,   97,   97,   97,   97,   74,   97,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       43,   44,   68,   96,   69,   97,   97,   97,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       89,   88,   88,   89,   89,   75,   77,   89,   80,   76,
       78,   79,   86,   86,   86,   55,   55,   54,   53,   52,
       40,   39,   39,   40,   38,   36,   36,   38,   38,   38,
       11,   13,   38,   17,   18,    9,   12,    8,   14,   10,

       32,   32,    3,   24,    7,   25,   37,   37,   37,   37,
       37,   37,   37,   15,   16,    0,    0,   95,    0,    0,
       73,   73,   73,   71,   82,   74,    0,   74,   74,   74,
       74,   74,    1,   74,   74,   74,   74,   74,   74,   74,
       74,   74,    0,    0,    0,    0,    0,    0,    0,    0,
       73,    0,    0,    0,   74,   74,   74,   74,   74,   74,
       74,   74,    1,   74,   74,   74,   74,   74,   74,   74,
       74,   74,    0,   81,    0,    0,   87,   83,   76,   86,
       86,   85,   56,   52,   41,   22,    0,   35,    0,    0,
       33,    0,   34,    0,   84,   30,    0,   32,   20,   23,

       19,   21,   37,   37,   37,   37,    4,   37,   37,    0,
       91,    0,   90,    0,    0,   93,    0,   73,   73,   70,
       70,   71,   72,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   48,   74,   74,   74,   67,    0,
       94,   73,    0,    0,   67,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   48,   74,   74,   74,
        0,    0,    0,   33,    0,    0,   31,    5,   37,    6,
       37,   37,    0,   92,   73,   70,   70,   72,   74,   47,
       74,   74,   46,   74,   74,   74,   74,   74,   74,   74,
       45,   74,   74,    0,    0,    0,   74,   47,   74,   74,

       46,   74,   74,   74,   74,   74,   74,   74,   45,   74,
       74,    0,    0,    0,    0,    0,   37,   37,    2,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       49,    0,    0,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   49,    0,   37,   37,   74,   74,   74,
       74,    0,   63,   74,   74,   74,   74,   74,   74,    0,
        0,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       37,   37,    0,   65,   74,   74,    0,   58,   74,    0,
       64,   74,   74,   74,   74,    0,   66,    0,   74,   74,
       74,   74,   74,   74,   37,   37,   74,   50,   74,   74,

       74,    0,   60,   74,   66,   74,   50,   74,   74,   74,
       26,   37,    0,   62,   74,   74,    0,   61,    0,   59,
       74,   37,   37,   74,   74,   74,   27,   28,    0,   57,
       74,   74,   37,   74,   74,   29,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   51,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       45,   46,   47,   48,   49,   50,   51,   52,   53,   39,
       54,   55,   56,   29,   57,    1,   58,   59,   60,   61,

       62,   63,   64,   65,   66,   39,   39,   67,   68,   69,
       70,   71,   72,   73,   74,   75,   76,   50,   77,   78,
       79,   39,   80,   29,   81,   82,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[83] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,   13,   14,
       14,   15,   16,   17,    1,   18,    1,   19,    1,   20,
       21,   22,   22,   22,   20,   23,   23,   23,   23,   23,
       23,   24,   23,   23,   23,   24,   23,   24,   23,   25,
       23,   26,   23,    1,    6,    1,   27,   20,   21,   22,
       22,   22,   20,   23,   23,   23,   23,   23,   24,   23,
       23,   23,   24,   23,   24,   23,   23,   26,   23,    1,
        1,    1
    } ;

static yyconst flex_int16_t yy_base[529] =
    {   0,
        0,   82,  164,    0,  244,  245,  247,  250,  242,  247,
      269,    0,  351,    0, 1026, 3288, 3288, 3288,    0, 1021,
        0, 3288, 3288, 1009,  242,    0, 1008,    0,    0,  402,
      405,  397,  398,  404,  410,  396,  394,  410,  415,  405,
     3288, 3288,    0,  474,  434,  918,  497,  473,  513,  526,
      570,  531,  563,  574,  506,  565,  596,  588,  617,  599,
     3288, 3288, 3288,  445,  925, 3288, 3288,  912, 3288,    0,
     3288, 3288,  917,  904,  856,    0, 3288, 3288, 3288,  439,
     3288, 3288, 3288,    0, 3288, 3288, 3288,  838,  460,  550,
     3288, 3288,  477, 3288, 3288, 3288, 3288, 3288, 3288,  842,

      604,  462, 3288,  239,  817,  782,  445,    0,  449,  495,
      493,  524,  545, 3288, 3288,  674,  801, 3288,  687,  768,
        0,  774,  442,    0, 3288,    0,  658,  527,  540,  592,
      606,  616,    0,  729,  582,  622,  740,  739,  732,  739,
      743,  738,  799,  770,    0,  654,  776,    0,  797,  817,
      822,  641,  836,  838,  848,  851,  866,  877,  860,  864,
      862,  868,  865,  870,  881,  898,  910,  882,  867,  907,
      913,  915,  465, 3288,  497,  616, 3288, 3288,    0,  609,
      578, 3288,    0,  944,    0, 3288,  550, 3288,  947,    0,
        0,  784, 3288,  949, 3288,  539,    0,  954, 3288, 3288,

     3288, 3288,    0,  812,  879,  876,    0,  827,  834,  989,
     3288,  564, 3288, 1027,  993, 1000,  554, 1006,  493,    0,
        0,    0,    0,  851,  920,  931,  949,  953,  922,  952,
     1061, 1067, 1068,  952,    0, 1069, 1070, 1081,    0, 1013,
     3288, 1016,  648,  558, 1130, 1104, 1151, 1083, 1093, 1122,
     1134, 1109, 1137, 1092, 1140, 1154, 1139, 1152, 1153, 1165,
     1194,  576,    0,    0,  594,    0, 3288,    0, 1134,    0,
     1139, 1148,  483, 3288,  476,    0,    0,    0, 1152,    0,
     1150, 1164,    0, 1173, 1178,  400, 1188, 1183, 1199, 1188,
        0, 1196, 1189,  666,  669, 1234, 1200, 1201, 1204, 1207,

     1202, 1218, 1211, 1220, 1214, 1226, 1248, 1244, 1225, 1235,
     1249, 1274,  664,    0,  778,    0, 1268, 1242,    0, 1254,
     1270, 1261, 1264, 1310, 1260, 1272, 1265, 1263, 1285, 1290,
        0,  789,  661, 1285, 1303, 1297, 1298, 1338, 1315, 1313,
     1317, 1333, 1329, 1304, 1228, 1308, 1298, 1389, 1316, 1313,
     1395, 1400, 3288, 1330, 1406, 1328, 1338, 1346, 1363,  783,
     1362, 1412, 1380, 1379, 1423, 1427, 1401, 1397, 1402, 1403,
     1390, 1383, 1454, 3288, 1396, 1414, 1471, 3288, 1419, 1483,
     3288, 1419, 1383, 1489, 1446, 1434, 3288, 1459, 1448, 1463,
     1464, 1465, 1507, 1466, 1455, 1446, 1533,    0, 1458, 1460,

     1536, 1539, 3288, 1550, 1510, 1554, 1482, 1521, 1565, 1568,
      384, 1498, 1579, 3288, 1516, 1523, 1594, 3288, 1597, 3288,
     1535, 1526, 1539, 1608, 1545, 1555,    0,  379, 1611, 3288,
     1563, 1576, 1580, 1581, 1586,    0, 1585, 1589, 1599, 1600,
     1586, 1596, 1588, 1599, 1600, 1604, 1611, 1619, 1615, 1617,
     1614, 1634,  245, 1657, 3288, 3288, 1724, 1751, 1778, 1805,
     1832, 1840, 1866, 1893, 1912, 1926, 1951, 1970, 1989, 2015,
     2036, 2055, 2082, 2109, 2125, 2152, 2179, 2195, 2222, 2245,
     2271, 2285, 2312, 2339, 2353, 2378, 2397, 2413, 2433, 2455,
     2481, 2505, 2527, 2547, 2574, 2596, 2621, 2637, 2664, 2691,

     2707, 2734, 2756, 2763, 2785, 2812, 2834, 1668, 2847, 2874,
     2901, 2928, 2955, 2982, 3009, 3036, 3063, 3082, 3105, 3128,
     3150, 3170, 3197, 3211, 3220, 3229, 3238, 3260
    } ;

static yyconst flex_int16_t yy_def[529] =
    {   0,
      456,  456,  456,    3,  457,  457,  458,  458,  459,  459,
      456,   11,  456,   13,  456,  456,  456,  456,  460,  461,
      462,  456,  456,  456,  463,  463,  464,  465,  466,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      456,  456,  463,  467,  468,  469,  470,  471,  472,  472,
      472,   51,   51,   51,   51,   51,   51,   51,   51,   51,
      456,  456,  456,  473,  474,  456,  456,  456,  456,  475,
      456,  456,  476,  476,  456,  477,  456,  456,  456,  456,
      456,  456,  456,  478,  456,  456,  456,  456,  479,  480,
      456,  456,  481,  456,  456,  456,  456,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  482,  482,  482,  482,
      482,  482,  482,  456,  456,  460,  461,  456,  456,  456,
      463,  463,  483,  484,  456,  465,  485,  465,  465,  465,
      465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  486,  487,  488,  489,  487,  490,  456,  488,
      491,  489,  489,  492,  493,  465,  494,  494,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  495,  456,  496,  497,  456,  456,  498,  499,
      499,  456,  500,  456,  501,  456,  502,  456,  503,  504,
      505,  506,  456,  507,  456,  456,  508,  456,  456,  456,

      456,  456,  509,  509,  509,  509,  509,  509,  509,  456,
      456,  510,  456,  456,  456,  456,  511,  512,  513,  514,
      515,  516,  517,  518,  518,  518,  518,  518,  518,  518,
      518,  518,  518,  518,  518,  518,  518,  518,  519,  456,
      456,  512,  456,  520,  521,  522,  522,  247,  247,  247,
      247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      523,  456,  524,  505,  456,  525,  456,  509,  509,  509,
      509,  509,  511,  456,  513,  514,  515,  517,  518,  518,
      518,  518,  518,  518,  518,  518,  518,  518,  518,  518,
      518,  518,  518,  520,  520,  520,  247,  247,  247,  247,

      247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      247,  523,  456,  526,  456,  527,  509,  509,  509,  518,
      518,  518,  518,  518,  518,  518,  518,  518,  518,  518,
      518,  456,  456,  247,  247,  247,  247,  247,  247,  247,
      247,  247,  247,  247,  523,  509,  509,  518,  518,  518,
      518,  456,  456,  518,  518,  518,  518,  518,  518,  456,
      528,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      509,  509,  456,  456,  518,  518,  456,  456,  518,  456,
      456,  518,  518,  518,  518,  528,  456,  528,  247,  247,
      247,  247,  247,  247,  509,  509,  518,  518,  518,  518,

      518,  456,  456,  518,  528,  247,  247,  247,  247,  247,
      509,  509,  456,  456,  518,  518,  456,  456,  456,  456,
      247,  509,  509,  518,  518,  247,  509,  509,  456,  456,
      518,  247,  509,  518,  247,  509,  518,  247,  518,  247,
      518,  247,  518,  247,  518,  247,  518,  247,  518,  247,
      518,  247,  518,  247,  456,    0,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456
    } ;

static yyconst flex_int16_t yy_nxt[3371] =
    {   0,
       16,   17,   18,   17,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   23,   24,   16,   25,   26,   27,   28,
       28,   28,   29,   16,   16,   16,   26,   26,   26,   30,
       28,   31,   28,   32,   28,   33,   28,   34,   28,   28,
       35,   28,   28,   36,   28,   37,   38,   39,   40,   28,
       28,   28,   28,   16,   16,   16,   28,   30,   28,   31,
       28,   32,   28,   33,   28,   34,   28,   35,   28,   28,
       36,   28,   37,   38,   39,   40,   28,   28,   28,   41,
       42,   43,   16,   44,   18,   44,   19,   16,   20,   21,
       16,   22,   16,   16,   16,   45,   46,   16,   47,   26,

       27,   28,   28,   28,   48,   16,   16,   16,   26,   26,
       26,   49,   50,   51,   50,   52,   50,   53,   50,   54,
       50,   50,   55,   50,   50,   56,   50,   57,   58,   59,
       60,   50,   50,   50,   50,   16,   16,   16,   28,   49,
       50,   51,   50,   52,   50,   53,   50,   54,   50,   55,
       50,   50,   56,   50,   57,   58,   59,   60,   50,   50,
       50,   41,   42,   43,   61,   62,   63,   62,   61,   64,
       65,   61,   61,   61,   61,   61,   66,   61,   61,   67,
       61,   61,   68,   61,   61,   61,   61,   61,   61,   69,
       61,   61,   61,   70,   70,   70,   70,   70,   70,   70,

       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   71,   61,   72,
       61,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   61,   61,   61,   74,   74,   77,   77,
       77,   77,   77,   77,   79,  122,  455,   75,   75,   79,
      123,   80,   80,   80,  199,  200,   80,   80,   80,   81,
       82,   83,   82,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   84,   84,

       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   81,   81,   81,   81,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   81,   81,
       81,   85,   86,   87,   86,   88,   89,   85,   90,   91,
       92,   93,   94,   95,   96,   97,   98,   99,   85,  100,
      101,  102,  102,   85,  103,  104,  105,  106,   85,   85,
      107,  108,  109,  108,  108,  108,  108,  108,  108,  108,
      108,  108,  110,  111,  108,  108,  108,  112,  113,  108,

      108,  108,  108,  108,  114,   85,  115,   85,  107,  108,
      109,  108,  108,  108,  108,  108,  108,  108,  108,  110,
      111,  108,  108,  108,  112,  113,  108,  108,  108,  108,
       85,   85,   85,  128,  129,  433,  131,  132,  133,  135,
      422,  137,  138,  139,  221,  134,  142,  130,  141,  148,
      174,  148,  136,  149,  149,  121,  325,  140,  184,  184,
      184,  128,  129,  131,  132,  188,  133,  135,  137,  138,
      174,  139,  134,  142,  130,  143,  141,  143,  274,  136,
      152,  198,  198,  198,  140,  274,  204,  193,  145,  153,
      145,  205,  127,  127,  127,  274,  146,  121,  121,  175,

      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      122,  121,  121,  204,  189,  123,  261,  261,  205,  175,
      121,  121,  121,  121,  121,  121,  147,  126,  155,  126,
      148,  194,  156,  156,  126,  165,  126,  206,  207,  147,
      126,  155,  126,  148,  158,  156,  156,  126,  166,  126,
      121,  121,  121,  121,  190,  188,  274,  190,  196,  196,
      157,  294,  295,  165,  206,  207,  213,  190,  190,  126,
      161,  208,  158,  157,  224,  166,  121,  121,  121,  225,
      181,  209,  126,  147,  126,  155,  126,  148,  157,  156,
      156,  126,  157,  126,  157,  313,  313,  161,  208,  159,

      157,  224,  162,  157,  189,  157,  225,  157,  163,  209,
      167,  181,  160,  315,  315,  164,  157,  157,  177,  230,
      157,  169,  157,  196,  196,  157,  126,  159,  157,  162,
      157,  157,  157,  226,  157,  170,  163,  167,  157,  160,
      172,  157,  164,  157,  168,  157,  157,  230,  456,  169,
      171,  243,  227,  157,  231,  197,  157,  157,  228,  157,
      226,  152,  170,  244,  360,  157,  361,  172,  157,  294,
      295,  168,  456,  456,  157,  210,  211,  210,  171,  227,
      223,  197,  231,  187,  187,  228,  157,  212,  212,  213,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,

      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      212,  212,  212,  212,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  212,  212,  212,  215,
      216,  215,  229,  232,  217,  218,  216,  218,  234,  235,
      219,  236,  233,  237,  238,  148,  360,  148,  361,  149,
      149,  148,  332,  148,  193,  149,  149,  192,  192,  229,

      143,  232,  143,  118,  333,  234,  235,  202,  236,  233,
      237,  238,  148,  145,  148,  145,  149,  149,  240,  241,
      240,  146,  121,  242,  241,  242,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  194,  243,
      121,  243,  201,  456,  268,  121,  121,  121,  121,  121,
      121,  244,  239,  244,  153,  195,  271,  127,  127,  127,
      223,  239,  126,  186,  126,  239,  155,  272,  148,  126,
      156,  156,  268,  239,  182,  121,  121,  121,  121,  147,
      126,  155,  126,  148,  271,  156,  156,  126,  279,  126,
      147,  126,  155,  126,  148,  272,  156,  156,  126,  247,

      126,  121,  121,  121,  126,  248,  181,  157,  249,  157,
      250,  157,  157,  251,  257,  157,  279,  157,  252,  181,
      269,  256,  126,  270,  246,  178,  247,  177,  157,  157,
      253,  120,  248,  126,  157,  249,  157,  250,  157,  157,
      251,  257,  157,  254,  157,  157,  252,  269,  256,  258,
      270,  246,  255,  259,  157,  157,  157,  157,  253,  280,
      157,  260,  157,  184,  184,  184,  262,  262,  265,  265,
      285,  254,  157,  198,  198,  198,  258,  281,  282,  255,
      259,  157,  283,  284,  157,  290,  280,  157,  260,  157,
      210,  211,  210,  286,  215,  216,  215,  285,  263,  217,

      266,  215,  216,  215,  281,  282,  217,  218,  216,  218,
      283,  284,  219,  290,  240,  241,  240,  242,  241,  242,
      286,  125,  120,  118,  263,  456,  266,  212,  212,  213,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      212,  212,  212,  212,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,

      214,  214,  214,  214,  214,  214,  212,  212,  212,  287,
      288,  289,  291,  292,  293,  456,  456,  147,  126,  155,
      126,  148,  157,  156,  156,  126,  301,  126,  456,  299,
      300,  157,  157,  456,  239,  306,  287,  288,  289,  291,
      292,  297,  293,  239,  126,  456,  126,  239,  157,  157,
      304,  126,  302,  456,  301,  239,  299,  300,  157,  157,
      126,  157,  306,  456,  147,  126,  155,  126,  148,  297,
      156,  156,  126,  157,  126,  157,  157,  304,  157,  157,
      302,  317,  303,  307,  318,  305,  126,  308,  157,  319,
      298,  157,  157,  157,  320,  309,  310,  321,  311,  174,

      157,  322,  323,  157,  157,  157,  157,  126,  317,  303,
      307,  318,  305,  312,  312,  308,  319,  298,  157,  157,
      157,  320,  309,  310,  321,  324,  311,  326,  327,  322,
      323,  157,  328,  174,  329,  330,  331,  332,  456,  157,
      157,  157,  334,  157,  336,  456,  157,  337,  175,  333,
      157,  335,  324,  339,  326,  327,  456,  157,  338,  157,
      328,  329,  330,  331,  157,  157,  157,  157,  157,  334,
      157,  340,  336,  157,  343,  337,  325,  157,  335,  174,
      339,  341,  175,  157,  157,  338,  157,  157,  157,  347,
      342,  157,  157,  345,  345,  348,  344,  346,  340,  349,

      456,  343,  350,  351,  354,  355,  456,  356,  357,  341,
      157,  352,  352,  352,  157,  157,  347,  342,  358,  359,
      456,  353,  348,  344,  157,  346,  362,  349,  175,  350,
      351,  354,  363,  355,  356,  357,  157,  365,  364,  352,
      352,  352,  157,  157,  372,  371,  358,  359,  366,  353,
      456,  157,  157,  362,  157,  367,  157,  375,  370,  382,
      363,  376,  368,  157,  365,  364,  369,  387,  157,  157,
      157,  372,  157,  371,  456,  456,  366,  157,  379,  157,
      456,  157,  367,  157,  375,  383,  370,  382,  376,  368,
      373,  373,  373,  384,  369,  157,  377,  377,  377,  157,

      374,  352,  352,  352,  157,  379,  378,  380,  380,  380,
      385,  353,  383,  373,  373,  373,  388,  381,  157,  157,
      384,  389,  456,  374,  377,  377,  377,  390,  380,  380,
      380,  395,  391,  396,  378,  401,  157,  385,  381,  387,
      157,  157,  157,  397,  392,  157,  157,  398,  389,  393,
      394,  157,  399,  400,  390,  373,  373,  373,  395,  396,
      391,  401,  157,  157,  405,  374,  157,  157,  157,  157,
      397,  392,  377,  377,  377,  398,  393,  394,  157,  404,
      399,  400,  378,  412,  380,  380,  380,  157,  388,  157,
      402,  402,  402,  157,  381,  406,  407,  416,  408,  410,

      403,  411,  157,  157,  157,  157,  415,  404,  402,  402,
      402,  412,  456,  388,  157,  387,  456,  409,  403,  456,
      456,  157,  406,  456,  407,  416,  408,  410,  411,  157,
      157,  157,  157,  415,  413,  413,  413,  417,  417,  417,
      402,  402,  402,  409,  414,  423,  157,  418,  157,  424,
      403,  419,  419,  419,  456,  413,  413,  413,  421,  456,
      157,  420,  425,  427,  388,  414,  417,  417,  417,  419,
      419,  419,  423,  157,  426,  428,  418,  424,  431,  420,
      413,  413,  413,  456,  456,  456,  421,  157,  432,  425,
      414,  427,  456,  157,  157,  417,  417,  417,  419,  419,

      419,  426,  434,  428,  157,  418,  431,  157,  420,  429,
      429,  429,  429,  429,  429,  435,  432,  436,  437,  430,
      157,  157,  430,  438,  456,  157,  439,  443,  157,  434,
      440,  157,  441,  442,  157,  157,  445,  444,  157,  157,
      447,  449,  435,  157,  448,  436,  437,  446,  451,  450,
      452,  438,  157,  439,  443,  157,  157,  440,  157,  453,
      441,  442,  157,  445,  444,  157,  157,  447,  455,  449,
      157,  448,  456,  157,  446,  456,  451,  450,  452,  454,
      456,  267,  456,  157,  456,  157,  453,  267,  267,  267,
      456,  456,  456,  456,  456,  456,  157,  456,  456,  456,

      157,  456,  456,  456,  456,  456,  454,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  157,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,

       78,   78,   78,   78,   78,  116,  456,  456,  456,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  117,  117,  117,  117,  117,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  117,  117,  119,
      119,  119,  119,  119,  119,  119,  121,  121,  456,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  124,  124,  124,  124,  124,  124,  124,

      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
      126,  126,  126,  456,  456,  126,  126,  456,  126,  456,
      456,  126,  126,  126,  126,  126,  126,  126,  126,  127,
      127,  456,  456,  456,  456,  127,  127,  127,  127,  127,
      127,  127,  144,  456,  144,  456,  456,  456,  144,  144,
      456,  144,  456,  456,  456,  456,  144,  456,  456,  456,
      144,  144,  144,  144,  144,  144,  144,  147,  456,  147,
      456,  147,  456,  147,  456,  456,  456,  456,  456,  147,
      147,  147,  147,  147,  147,  147,  150,  456,  456,  150,

      150,  456,  150,  150,  150,  456,  456,  456,  150,  150,
      150,  150,  150,  150,  150,  151,  151,  456,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  154,  456,  456,  456,  154,  456,  456,  154,
      154,  456,  456,  456,  456,  154,  154,  154,  154,  154,
      154,  154,  157,  157,  157,  157,  157,  456,  157,  157,
      456,  157,  456,  456,  157,  157,  157,  157,  157,  157,
      157,  157,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,

      173,  173,  173,  173,  173,  173,  173,  173,  173,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  179,  456,  179,  179,
      456,  456,  456,  456,  179,  179,  179,  179,  179,  179,
      179,  179,  180,  180,  180,  180,  180,  180,  180,  456,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  183,
      456,  456,  456,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,

      183,  183,  183,  183,  183,  183,  185,  456,  185,  185,
      456,  456,  456,  456,  185,  185,  185,  185,  185,  185,
      185,  185,  187,  187,  187,  187,  187,  187,  456,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  191,
      456,  191,  456,  456,  456,  456,  191,  191,  456,  456,
      456,  456,  456,  456,  191,  191,  191,  191,  191,  191,
      191,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  203,  203,

      456,  456,  456,  456,  203,  203,  203,  203,  203,  203,
      203,  203,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  222,
      222,  456,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  127,  127,  127,  456,
      456,  456,  127,  127,  127,  127,  127,  127,  127,  144,
      456,  144,  456,  456,  456,  144,  144,  456,  144,  456,
      456,  456,  456,  144,  456,  456,  456,  144,  144,  144,

      144,  144,  144,  144,  147,  456,  147,  456,  147,  456,
      147,  456,  456,  456,  456,  456,  147,  147,  147,  147,
      147,  147,  147,  150,  150,  456,  150,  150,  150,  456,
      456,  456,  150,  150,  150,  150,  150,  150,  150,  153,
      456,  456,  456,  153,  456,  456,  456,  456,  456,  456,
      456,  456,  153,  153,  153,  153,  153,  153,  153,  239,
      456,  456,  239,  456,  239,  456,  239,  456,  239,  456,
      456,  239,  239,  456,  239,  239,  239,  239,  239,  239,
      239,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,

      151,  151,  151,  151,  151,  151,  151,  151,  154,  456,
      456,  456,  456,  456,  154,  154,  456,  456,  154,  154,
      154,  456,  456,  456,  154,  154,  154,  154,  154,  154,
      154,  245,  456,  456,  245,  245,  245,  245,  245,  456,
      245,  245,  456,  245,  245,  456,  245,  245,  245,  245,
      245,  245,  245,  245,  157,  157,  157,  157,  157,  456,
      157,  157,  456,  157,  456,  456,  157,  157,  157,  157,
      157,  157,  157,  157,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,

      173,  173,  456,  456,  456,  456,  456,  456,  456,  173,
      456,  456,  456,  456,  173,  173,  173,  456,  456,  173,
      173,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  179,  456,
      179,  179,  456,  456,  456,  456,  179,  179,  179,  179,
      179,  179,  179,  179,  180,  180,  180,  180,  180,  180,
      180,  456,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  183,  456,  456,  456,  183,  183,  183,  183,  183,

      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  185,  456,
      185,  185,  456,  456,  456,  456,  185,  185,  185,  185,
      185,  185,  185,  185,  187,  187,  187,  187,  187,  187,
      456,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  456,  456,  456,  456,  456,  456,  187,
      456,  456,  456,  456,  456,  456,  187,  456,  456,  187,
      456,  187,  191,  191,  191,  191,  191,  191,  191,  264,
      456,  456,  456,  456,  456,  264,  264,  456,  264,  264,

      456,  456,  456,  456,  264,  264,  264,  264,  264,  264,
      264,  264,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  456,  456,  456,  456,  456,  456,  192,  456,  456,
      456,  456,  456,  456,  192,  456,  456,  192,  456,  192,
      203,  203,  456,  456,  456,  456,  203,  203,  203,  203,
      203,  203,  203,  203,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,

      212,  273,  273,  273,  273,  273,  273,  273,  273,  273,
      273,  273,  273,  273,  273,  273,  273,  273,  273,  273,
      273,  273,  273,  273,  273,  273,  273,  273,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  275,  275,  275,  275,  275,
      275,  275,  275,  275,  275,  275,  275,  275,  275,  275,
      275,  275,  275,  275,  275,  275,  275,  275,  275,  275,
      275,  275,  276,  276,  456,  276,  276,  276,  276,  276,
      276,  276,  276,  276,  276,  276,  276,  276,  276,  276,

      276,  276,  276,  276,  276,  276,  276,  276,  276,  277,
      277,  456,  277,  277,  277,  277,  277,  277,  277,  277,
      277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
      277,  277,  277,  277,  277,  277,  222,  222,  456,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  278,  278,  456,  278,  278,  278,  278,
      278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
      278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
      126,  126,  126,  456,  456,  126,  126,  456,  126,  456,

      456,  126,  126,  126,  126,  126,  126,  126,  126,  239,
      456,  456,  239,  456,  239,  456,  239,  456,  239,  456,
      456,  239,  239,  456,  239,  239,  239,  239,  239,  239,
      239,  296,  296,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  296,  296,  296,
      296,  296,  296,  296,  245,  456,  456,  245,  245,  245,
      245,  245,  456,  245,  245,  456,  245,  245,  456,  245,
      245,  245,  245,  245,  245,  245,  245,  157,  157,  157,
      157,  157,  456,  157,  157,  456,  157,  456,  456,  157,
      157,  157,  157,  157,  157,  157,  157,  173,  173,  173,

      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  314,  314,  456,  456,  456,  456,
      314,  314,  314,  316,  316,  456,  456,  456,  456,  316,
      316,  316,  187,  187,  456,  456,  456,  456,  187,  187,
      187,  192,  192,  456,  456,  456,  456,  192,  192,  192,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,   15,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456
    } ;

static yyconst flex_int16_t yy_chk[3371] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    5,    6,    7,    7,
        7,    8,    8,    8,    9,   25,  453,    5,    6,   10,
       25,    9,    9,    9,  104,  104,   10,   10,   10,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   30,   31,  428,   32,   33,   34,   35,
      411,   36,   37,   38,  123,   34,   40,   31,   39,   45,
       64,   45,   35,   45,   45,  123,  286,   38,   80,   80,
       80,   30,   31,   32,   33,   89,   34,   35,   36,   37,
      173,   38,   34,   40,   31,   44,   39,   44,  275,   35,
       48,  102,  102,  102,   38,  273,  107,   93,   44,   48,
       44,  109,   48,   48,   48,  219,   44,   47,   47,   64,

       47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
       47,   47,   47,  107,   89,   47,  175,  175,  109,  173,
       47,   47,   47,   47,   47,   47,   49,   49,   49,   49,
       49,   93,   49,   49,   49,   55,   49,  110,  111,   50,
       50,   50,   50,   50,   49,   50,   50,   50,   55,   50,
       47,   47,   47,   47,   90,  187,  217,   90,  196,  196,
       52,  244,  244,   55,  110,  111,  212,   90,   90,   49,
       52,  112,   49,   52,  128,   55,   47,   47,   47,  129,
      181,  113,   50,   51,   51,   51,   51,   51,   52,   51,
       51,   51,   53,   51,   56,  262,  262,   52,  112,   51,

       52,  128,   53,   54,  187,   53,  129,   56,   54,  113,
       56,  180,   51,  265,  265,   54,   54,   58,  176,  135,
       53,   58,   56,  101,  101,   57,   51,   51,   60,   53,
       58,   54,   53,  130,   56,   58,   54,   56,   57,   51,
       60,   60,   54,   54,   57,   58,   59,  135,  152,   58,
       59,  243,  131,   57,  136,  101,   60,   58,  132,   59,
      130,  146,   58,  243,  333,   57,  333,   60,   60,  294,
      294,   57,  295,  295,   59,  116,  116,  116,   59,  131,
      127,  101,  136,  313,  313,  132,   59,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  120,
      120,  120,  134,  137,  120,  122,  122,  122,  138,  139,
      122,  140,  137,  141,  142,  144,  360,  144,  360,  144,
      144,  147,  332,  147,  192,  147,  147,  315,  315,  134,

      143,  137,  143,  117,  332,  138,  139,  106,  140,  137,
      141,  142,  149,  143,  149,  143,  149,  149,  150,  150,
      150,  143,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  192,  153,
      151,  154,  105,  153,  204,  151,  151,  151,  151,  151,
      151,  153,  155,  154,  154,  100,  208,  154,  154,  154,
      154,  155,  155,   88,  155,  155,  156,  209,  156,  155,
      156,  156,  204,  155,   75,  151,  151,  151,  151,  157,
      157,  157,  157,  157,  208,  157,  157,  157,  224,  157,
      158,  158,  158,  158,  158,  209,  158,  158,  158,  159,

      158,  151,  151,  151,  155,  160,   74,  159,  161,  161,
      162,  160,  163,  164,  169,  162,  224,  164,  165,   73,
      205,  168,  157,  206,  158,   68,  159,   65,  165,  168,
      166,   46,  160,  158,  159,  161,  161,  162,  160,  163,
      164,  169,  162,  167,  164,  166,  165,  205,  168,  170,
      206,  158,  167,  171,  170,  165,  168,  167,  166,  225,
      171,  172,  172,  184,  184,  184,  189,  189,  194,  194,
      229,  167,  166,  198,  198,  198,  170,  226,  226,  167,
      171,  170,  227,  228,  167,  234,  225,  171,  172,  172,
      210,  210,  210,  230,  215,  215,  215,  229,  189,  215,

      194,  216,  216,  216,  226,  226,  216,  218,  218,  218,
      227,  228,  218,  234,  240,  240,  240,  242,  242,  242,
      230,   27,   24,   20,  189,   15,  194,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  214,  214,  214,

      214,  214,  214,  214,  214,  214,  214,  214,  214,  231,
      232,  233,  236,  237,  238,    0,    0,  246,  246,  246,
      246,  246,  248,  246,  246,  246,  249,  246,    0,  248,
      248,  254,  249,    0,  245,  254,  231,  232,  233,  236,
      237,  246,  238,  245,  245,    0,  245,  245,  252,  248,
      252,  245,  250,    0,  249,  245,  248,  248,  254,  249,
      246,  250,  254,    0,  247,  247,  247,  247,  247,  246,
      247,  247,  247,  251,  247,  252,  253,  252,  257,  255,
      250,  269,  251,  255,  271,  253,  245,  256,  250,  272,
      247,  258,  259,  256,  279,  258,  259,  281,  260,  261,

      251,  282,  284,  253,  260,  257,  255,  247,  269,  251,
      255,  271,  253,  261,  261,  256,  272,  247,  258,  259,
      256,  279,  258,  259,  281,  285,  260,  287,  288,  282,
      284,  260,  289,  345,  290,  292,  293,  296,  296,  297,
      298,  301,  297,  299,  300,    0,  300,  302,  261,  296,
      303,  299,  285,  305,  287,  288,    0,  302,  303,  304,
      289,  290,  292,  293,  309,  306,  297,  298,  301,  297,
      299,  306,  300,  300,  310,  302,  304,  303,  299,  312,
      305,  307,  345,  308,  302,  303,  304,  307,  311,  318,
      308,  309,  306,  312,  312,  320,  311,  317,  306,  321,

        0,  310,  322,  323,  325,  326,    0,  327,  328,  307,
      308,  324,  324,  324,  307,  311,  318,  308,  329,  330,
        0,  324,  320,  311,  334,  317,  334,  321,  312,  322,
      323,  325,  335,  326,  327,  328,  336,  337,  336,  338,
      338,  338,  335,  344,  347,  346,  329,  330,  339,  338,
        0,  334,  340,  334,  339,  340,  341,  349,  343,  356,
      335,  350,  341,  336,  337,  336,  342,  361,  343,  335,
      344,  347,  342,  346,    0,    0,  339,  338,  354,  340,
        0,  339,  340,  341,  349,  357,  343,  356,  350,  341,
      348,  348,  348,  358,  342,  343,  351,  351,  351,  342,

      348,  352,  352,  352,  338,  354,  351,  355,  355,  355,
      359,  352,  357,  362,  362,  362,  361,  355,  364,  363,
      358,  363,    0,  362,  365,  365,  365,  364,  366,  366,
      366,  371,  367,  372,  365,  383,  368,  359,  366,  386,
      367,  369,  370,  375,  368,  364,  363,  376,  363,  369,
      370,  362,  379,  382,  364,  373,  373,  373,  371,  372,
      367,  383,  365,  368,  388,  373,  366,  367,  369,  370,
      375,  368,  377,  377,  377,  376,  369,  370,  362,  385,
      379,  382,  377,  396,  380,  380,  380,  389,  386,  365,
      384,  384,  384,  366,  380,  389,  390,  400,  391,  394,

      384,  395,  390,  391,  392,  394,  399,  385,  393,  393,
      393,  396,    0,  388,  389,  405,    0,  392,  393,    0,
        0,  407,  389,    0,  390,  400,  391,  394,  395,  390,
      391,  392,  394,  399,  397,  397,  397,  401,  401,  401,
      402,  402,  402,  392,  397,  412,  393,  401,  407,  415,
      402,  404,  404,  404,    0,  406,  406,  406,  408,    0,
      408,  404,  416,  422,  405,  406,  409,  409,  409,  410,
      410,  410,  412,  393,  421,  423,  409,  415,  425,  410,
      413,  413,  413,    0,    0,    0,  408,  408,  426,  416,
      413,  422,    0,  406,  426,  417,  417,  417,  419,  419,

      419,  421,  431,  423,  409,  417,  425,  410,  419,  424,
      424,  424,  429,  429,  429,  432,  426,  433,  434,  424,
      406,  426,  429,  435,    0,  435,  437,  441,  438,  431,
      438,  409,  439,  440,  410,  442,  443,  442,  444,  440,
      445,  447,  432,  446,  446,  433,  434,  444,  449,  448,
      450,  435,  435,  437,  441,  438,  450,  438,  448,  451,
      439,  440,  442,  443,  442,  444,  440,  445,  454,  447,
      446,  446,    0,  452,  444,    0,  449,  448,  450,  452,
        0,  508,    0,  450,    0,  448,  451,  508,  508,  508,
        0,    0,    0,    0,    0,    0,  454,    0,    0,    0,

      452,    0,    0,    0,    0,    0,  452,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  454,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,

      459,  459,  459,  459,  459,  460,    0,    0,    0,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  462,
      462,  462,  462,  462,  462,  462,  463,  463,    0,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  464,  464,  464,  464,  464,  464,  464,

      464,  464,  464,  464,  464,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  464,  464,
      465,  465,  465,    0,    0,  465,  465,    0,  465,    0,
        0,  465,  465,  465,  465,  465,  465,  465,  465,  466,
      466,    0,    0,    0,    0,  466,  466,  466,  466,  466,
      466,  466,  467,    0,  467,    0,    0,    0,  467,  467,
        0,  467,    0,    0,    0,    0,  467,    0,    0,    0,
      467,  467,  467,  467,  467,  467,  467,  468,    0,  468,
        0,  468,    0,  468,    0,    0,    0,    0,    0,  468,
      468,  468,  468,  468,  468,  468,  469,    0,    0,  469,

      469,    0,  469,  469,  469,    0,    0,    0,  469,  469,
      469,  469,  469,  469,  469,  470,  470,    0,  470,  470,
      470,  470,  470,  470,  470,  470,  470,  470,  470,  470,
      470,  470,  470,  470,  470,  470,  470,  470,  470,  470,
      470,  470,  471,    0,    0,    0,  471,    0,    0,  471,
      471,    0,    0,    0,    0,  471,  471,  471,  471,  471,
      471,  471,  472,  472,  472,  472,  472,    0,  472,  472,
        0,  472,    0,    0,  472,  472,  472,  472,  472,  472,
      472,  472,  473,  473,  473,  473,  473,  473,  473,  473,
      473,  473,  473,  473,  473,  473,  473,  473,  473,  473,

      473,  473,  473,  473,  473,  473,  473,  473,  473,  474,
      474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
      474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
      474,  474,  474,  474,  474,  474,  475,    0,  475,  475,
        0,    0,    0,    0,  475,  475,  475,  475,  475,  475,
      475,  475,  476,  476,  476,  476,  476,  476,  476,    0,
      476,  476,  476,  476,  476,  476,  476,  476,  476,  476,
      476,  476,  476,  476,  476,  476,  476,  476,  476,  477,
        0,    0,    0,  477,  477,  477,  477,  477,  477,  477,
      477,  477,  477,  477,  477,  477,  477,  477,  477,  477,

      477,  477,  477,  477,  477,  477,  478,    0,  478,  478,
        0,    0,    0,    0,  478,  478,  478,  478,  478,  478,
      478,  478,  479,  479,  479,  479,  479,  479,    0,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  480,
        0,  480,    0,    0,    0,    0,  480,  480,    0,    0,
        0,    0,    0,    0,  480,  480,  480,  480,  480,  480,
      480,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  482,  482,

        0,    0,    0,    0,  482,  482,  482,  482,  482,  482,
      482,  482,  483,  483,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  483,  483,  484,
      484,    0,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  485,  485,  485,    0,
        0,    0,  485,  485,  485,  485,  485,  485,  485,  486,
        0,  486,    0,    0,    0,  486,  486,    0,  486,    0,
        0,    0,    0,  486,    0,    0,    0,  486,  486,  486,

      486,  486,  486,  486,  487,    0,  487,    0,  487,    0,
      487,    0,    0,    0,    0,    0,  487,  487,  487,  487,
      487,  487,  487,  488,  488,    0,  488,  488,  488,    0,
        0,    0,  488,  488,  488,  488,  488,  488,  488,  489,
        0,    0,    0,  489,    0,    0,    0,    0,    0,    0,
        0,    0,  489,  489,  489,  489,  489,  489,  489,  490,
        0,    0,  490,    0,  490,    0,  490,    0,  490,    0,
        0,  490,  490,    0,  490,  490,  490,  490,  490,  490,
      490,  491,  491,  491,  491,  491,  491,  491,  491,  491,
      491,  491,  491,  491,  491,  491,  491,  491,  491,  491,

      491,  491,  491,  491,  491,  491,  491,  491,  492,    0,
        0,    0,    0,    0,  492,  492,    0,    0,  492,  492,
      492,    0,    0,    0,  492,  492,  492,  492,  492,  492,
      492,  493,    0,    0,  493,  493,  493,  493,  493,    0,
      493,  493,    0,  493,  493,    0,  493,  493,  493,  493,
      493,  493,  493,  493,  494,  494,  494,  494,  494,    0,
      494,  494,    0,  494,    0,    0,  494,  494,  494,  494,
      494,  494,  494,  494,  495,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,

      495,  496,    0,    0,    0,    0,    0,    0,    0,  496,
        0,    0,    0,    0,  496,  496,  496,    0,    0,  496,
      496,  497,  497,  497,  497,  497,  497,  497,  497,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  497,  497,
      497,  497,  497,  497,  497,  497,  497,  497,  498,    0,
      498,  498,    0,    0,    0,    0,  498,  498,  498,  498,
      498,  498,  498,  498,  499,  499,  499,  499,  499,  499,
      499,    0,  499,  499,  499,  499,  499,  499,  499,  499,
      499,  499,  499,  499,  499,  499,  499,  499,  499,  499,
      499,  500,    0,    0,    0,  500,  500,  500,  500,  500,

      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
      500,  500,  500,  500,  500,  500,  500,  500,  501,    0,
      501,  501,    0,    0,    0,    0,  501,  501,  501,  501,
      501,  501,  501,  501,  502,  502,  502,  502,  502,  502,
        0,  502,  502,  502,  502,  502,  502,  502,  502,  502,
      502,  502,  502,  502,  502,  502,  502,  502,  502,  502,
      502,  503,  503,    0,    0,    0,    0,    0,    0,  503,
        0,    0,    0,    0,    0,    0,  503,    0,    0,  503,
        0,  503,  504,  504,  504,  504,  504,  504,  504,  505,
        0,    0,    0,    0,    0,  505,  505,    0,  505,  505,

        0,    0,    0,    0,  505,  505,  505,  505,  505,  505,
      505,  505,  506,  506,  506,  506,  506,  506,  506,  506,
      506,  506,  506,  506,  506,  506,  506,  506,  506,  506,
      506,  506,  506,  506,  506,  506,  506,  506,  506,  507,
      507,    0,    0,    0,    0,    0,    0,  507,    0,    0,
        0,    0,    0,    0,  507,    0,    0,  507,    0,  507,
      509,  509,    0,    0,    0,    0,  509,  509,  509,  509,
      509,  509,  509,  509,  510,  510,  510,  510,  510,  510,
      510,  510,  510,  510,  510,  510,  510,  510,  510,  510,
      510,  510,  510,  510,  510,  510,  510,  510,  510,  510,

      510,  511,  511,  511,  511,  511,  511,  511,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  511,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  511,  512,  512,
      512,  512,  512,  512,  512,  512,  512,  512,  512,  512,
      512,  512,  512,  512,  512,  512,  512,  512,  512,  512,
      512,  512,  512,  512,  512,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  513,  514,  514,    0,  514,  514,  514,  514,  514,
      514,  514,  514,  514,  514,  514,  514,  514,  514,  514,

      514,  514,  514,  514,  514,  514,  514,  514,  514,  515,
      515,    0,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  515,  515,  516,  516,    0,  516,
      516,  516,  516,  516,  516,  516,  516,  516,  516,  516,
      516,  516,  516,  516,  516,  516,  516,  516,  516,  516,
      516,  516,  516,  517,  517,    0,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      517,  517,  517,  517,  517,  517,  517,  517,  517,  517,
      518,  518,  518,    0,    0,  518,  518,    0,  518,    0,

        0,  518,  518,  518,  518,  518,  518,  518,  518,  519,
        0,    0,  519,    0,  519,    0,  519,    0,  519,    0,
        0,  519,  519,    0,  519,  519,  519,  519,  519,  519,
      519,  520,  520,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  520,  520,  520,
      520,  520,  520,  520,  521,    0,    0,  521,  521,  521,
      521,  521,    0,  521,  521,    0,  521,  521,    0,  521,
      521,  521,  521,  521,  521,  521,  521,  522,  522,  522,
      522,  522,    0,  522,  522,    0,  522,    0,    0,  522,
      522,  522,  522,  522,  522,  522,  522,  523,  523,  523,

      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      523,  523,  523,  523,  524,  524,    0,    0,    0,    0,
      524,  524,  524,  525,  525,    0,    0,    0,    0,  525,
      525,  525,  526,  526,    0,    0,    0,    0,  526,  526,
      526,  527,  527,    0,    0,    0,    0,  527,  527,  527,
      528,  528,  528,  528,  528,  528,  528,  528,  528,  528,
      528,  528,  528,  528,  528,  528,  528,  528,  528,  528,
      528,  528,  528,  528,  528,  528,  528,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,

      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[99] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 
    0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 63 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
#if !defined(__FreeBSD__)
int fileno(FILE *stream);
#endif

#line 1481 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define EXPR 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 97 "lexer.l"


 /* keywords */
#line 1679 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 457 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3288 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 100 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 101 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 102 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 103 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 104 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 105 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 107 "lexer.l"
case 8:
#line 108 "lexer.l"
case 9:
#line 109 "lexer.l"
case 10:
#line 110 "lexer.l"
case 11:
#line 111 "lexer.l"
case 12:
#line 112 "lexer.l"
case 13:
#line 113 "lexer.l"
case 14:
#line 114 "lexer.l"
case 15:
#line 115 "lexer.l"
case 16:
#line 116 "lexer.l"
case 17:
#line 117 "lexer.l"
case 18:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 22:
#line 122 "lexer.l"
case 23:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 123 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 124 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 125 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 126 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 127 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 128 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 30:
#line 130 "lexer.l"
case 31:
#line 131 "lexer.l"
case 32:
YY_RULE_SETUP
#line 131 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 132 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 133 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 138 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
#line 143 "lexer.l"

	YY_BREAK
case 37:
YY_RULE_SETUP
#line 144 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 146 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 149 "lexer.l"

	YY_BREAK
case 40:
YY_RULE_SETUP
#line 150 "lexer.l"
{ parser_errmsg("invalid character '%s' in 'call' statement"
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 153 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 156 "lexer.l"
{ return '&'; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 157 "lexer.l"
{ return '{'; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 158 "lexer.l"
{ return '}'; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 159 "lexer.l"
{ return STOP; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 160 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 161 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 162 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 163 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 164 "lexer.l"
{ return CONTINUE; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 51:
YY_RULE_SETUP
#line 168 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 169 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 170 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 171 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 175 "lexer.l"

	YY_BREAK
case 56:
YY_RULE_SETUP
#line 176 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 179 "lexer.l"
{ yylval.objType = CNFOBJ_MAINQ;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 181 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 183 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 185 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 187 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 189 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 191 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 193 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 195 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 196 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext));
				  dbgprintf("lexer: propfilt is '%s'\n", yylval.s);
				  return PROPFILT;
				  }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 201 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 68:
#line 203 "lexer.l"
case 69:
#line 204 "lexer.l"
case 70:
/* rule 70 can match eol */
#line 205 "lexer.l"
case 71:
/* rule 71 can match eol */
#line 206 "lexer.l"
case 72:
/* rule 72 can match eol */
#line 207 "lexer.l"
case 73:
/* rule 73 can match eol */
#line 208 "lexer.l"
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 208 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 209 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 210 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 77:
#line 213 "lexer.l"
case 78:
#line 214 "lexer.l"
case 79:
#line 215 "lexer.l"
case 80:
YY_RULE_SETUP
#line 215 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 216 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 82:
YY_RULE_SETUP
#line 223 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 224 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 84:
YY_RULE_SETUP
#line 225 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 226 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 227 "lexer.l"

	YY_BREAK
case 87:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 228 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 229 "lexer.l"

	YY_BREAK
case 89:
YY_RULE_SETUP
#line 230 "lexer.l"
{ parser_errmsg("invalid character '%s' in object definition "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 90:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 233 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 91:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 244 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 92:
/* rule 92 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 245 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 93:
/* rule 93 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 246 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 94:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 247 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 248 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 96:
/* rule 96 can match eol */
YY_RULE_SETUP
#line 249 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 250 "lexer.l"
{ parser_errmsg("invalid character '%s' "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(EXPR):
#line 253 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 255 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2306 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 457 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 457 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 456);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 255 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
	dbgprintf("config parser: pushed file %s on top of stack\n", fname);

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	dbgprintf("config parser: reached end of file %s\n", bs->fn);
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL) {
		dbgprintf("config parser: parsing completed\n");
		return 1; /* all processed */
	}
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	dbgprintf("config parser: resume parsing of file %s at line %d\n",
		  cnfcurrfn, yylineno);
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

